<?php
/**
 * ProductCategoriesApi
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\CmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Cms.
 *
 * Управление контентом
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CmsClient\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Ensi\CmsClient\ApiException;
use Ensi\CmsClient\Configuration;
use Ensi\CmsClient\HeaderSelector;
use Ensi\CmsClient\ObjectSerializer;

/**
 * ProductCategoriesApi Class Doc Comment
 *
 * @category Class
 * @package  Ensi\CmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class ProductCategoriesApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int Host index
     */
    protected $hostIndex;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $host_index (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null,
        $host_index = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $host_index;
    }

    /**
     * Set the host index
     *
     * @param  int Host index (required)
     */
    public function setHostIndex($host_index)
    {
        $this->hostIndex = $host_index;
    }

    /**
     * Get the host index
     *
     * @return Host index
     */
    public function getHostIndex()
    {
        return $this->hostIndex;
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation createProductCategory
     *
     * Создание объекта типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\ProductCategoryForCreate $product_category_for_create product_category_for_create (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CmsClient\Dto\CreateProductCategoriesResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse
     */
    public function createProductCategory($product_category_for_create)
    {
        list($response) = $this->createProductCategoryWithHttpInfo($product_category_for_create);
        return $response;
    }

    /**
     * Operation createProductCategoryWithHttpInfo
     *
     * Создание объекта типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\ProductCategoryForCreate $product_category_for_create (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CmsClient\Dto\CreateProductCategoriesResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function createProductCategoryWithHttpInfo($product_category_for_create)
    {
        $request = $this->createProductCategoryRequest($product_category_for_create);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 201:
                    if ('\Ensi\CmsClient\Dto\CreateProductCategoriesResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\CreateProductCategoriesResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 404:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CmsClient\Dto\CreateProductCategoriesResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\CreateProductCategoriesResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation createProductCategoryAsync
     *
     * Создание объекта типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\ProductCategoryForCreate $product_category_for_create (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createProductCategoryAsync($product_category_for_create)
    {
        return $this->createProductCategoryAsyncWithHttpInfo($product_category_for_create)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation createProductCategoryAsyncWithHttpInfo
     *
     * Создание объекта типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\ProductCategoryForCreate $product_category_for_create (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createProductCategoryAsyncWithHttpInfo($product_category_for_create)
    {
        $returnType = '\Ensi\CmsClient\Dto\CreateProductCategoriesResponse';
        $request = $this->createProductCategoryRequest($product_category_for_create);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'createProductCategory'
     *
     * @param  \Ensi\CmsClient\Dto\ProductCategoryForCreate $product_category_for_create (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function createProductCategoryRequest($product_category_for_create)
    {
        // verify the required parameter 'product_category_for_create' is set
        if ($product_category_for_create === null || (is_array($product_category_for_create) && count($product_category_for_create) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $product_category_for_create when calling createProductCategory'
            );
        }

        $resourcePath = '/contents/product-categories';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;




        // body params
        $_tempBody = null;
        if (isset($product_category_for_create)) {
            $_tempBody = $product_category_for_create;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation deleteProductCategory
     *
     * Запрос на удаление ProductCategory
     *
     * @param  int $id Числовой id (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CmsClient\Dto\EmptyDataResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse
     */
    public function deleteProductCategory($id)
    {
        list($response) = $this->deleteProductCategoryWithHttpInfo($id);
        return $response;
    }

    /**
     * Operation deleteProductCategoryWithHttpInfo
     *
     * Запрос на удаление ProductCategory
     *
     * @param  int $id Числовой id (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CmsClient\Dto\EmptyDataResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteProductCategoryWithHttpInfo($id)
    {
        $request = $this->deleteProductCategoryRequest($id);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CmsClient\Dto\EmptyDataResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\EmptyDataResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 404:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CmsClient\Dto\EmptyDataResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\EmptyDataResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation deleteProductCategoryAsync
     *
     * Запрос на удаление ProductCategory
     *
     * @param  int $id Числовой id (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteProductCategoryAsync($id)
    {
        return $this->deleteProductCategoryAsyncWithHttpInfo($id)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation deleteProductCategoryAsyncWithHttpInfo
     *
     * Запрос на удаление ProductCategory
     *
     * @param  int $id Числовой id (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteProductCategoryAsyncWithHttpInfo($id)
    {
        $returnType = '\Ensi\CmsClient\Dto\EmptyDataResponse';
        $request = $this->deleteProductCategoryRequest($id);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'deleteProductCategory'
     *
     * @param  int $id Числовой id (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function deleteProductCategoryRequest($id)
    {
        // verify the required parameter 'id' is set
        if ($id === null || (is_array($id) && count($id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $id when calling deleteProductCategory'
            );
        }
        if ($id < 1) {
            throw new \InvalidArgumentException('invalid value for "$id" when calling ProductCategoriesApi.deleteProductCategory, must be bigger than or equal to 1.');
        }


        $resourcePath = '/contents/product-categories/{id}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                '{' . 'id' . '}',
                ObjectSerializer::toPathValue($id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'DELETE',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getProductCategoriesTree
     *
     * Формирование дерева категорий
     *
     * @param  \Ensi\CmsClient\Dto\ProductCategoriesTreeRequest $product_categories_tree_request product_categories_tree_request (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CmsClient\Dto\ProductCategoriesTreeResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse
     */
    public function getProductCategoriesTree($product_categories_tree_request)
    {
        list($response) = $this->getProductCategoriesTreeWithHttpInfo($product_categories_tree_request);
        return $response;
    }

    /**
     * Operation getProductCategoriesTreeWithHttpInfo
     *
     * Формирование дерева категорий
     *
     * @param  \Ensi\CmsClient\Dto\ProductCategoriesTreeRequest $product_categories_tree_request (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CmsClient\Dto\ProductCategoriesTreeResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function getProductCategoriesTreeWithHttpInfo($product_categories_tree_request)
    {
        $request = $this->getProductCategoriesTreeRequest($product_categories_tree_request);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CmsClient\Dto\ProductCategoriesTreeResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ProductCategoriesTreeResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CmsClient\Dto\ProductCategoriesTreeResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ProductCategoriesTreeResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getProductCategoriesTreeAsync
     *
     * Формирование дерева категорий
     *
     * @param  \Ensi\CmsClient\Dto\ProductCategoriesTreeRequest $product_categories_tree_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getProductCategoriesTreeAsync($product_categories_tree_request)
    {
        return $this->getProductCategoriesTreeAsyncWithHttpInfo($product_categories_tree_request)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getProductCategoriesTreeAsyncWithHttpInfo
     *
     * Формирование дерева категорий
     *
     * @param  \Ensi\CmsClient\Dto\ProductCategoriesTreeRequest $product_categories_tree_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getProductCategoriesTreeAsyncWithHttpInfo($product_categories_tree_request)
    {
        $returnType = '\Ensi\CmsClient\Dto\ProductCategoriesTreeResponse';
        $request = $this->getProductCategoriesTreeRequest($product_categories_tree_request);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getProductCategoriesTree'
     *
     * @param  \Ensi\CmsClient\Dto\ProductCategoriesTreeRequest $product_categories_tree_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getProductCategoriesTreeRequest($product_categories_tree_request)
    {
        // verify the required parameter 'product_categories_tree_request' is set
        if ($product_categories_tree_request === null || (is_array($product_categories_tree_request) && count($product_categories_tree_request) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $product_categories_tree_request when calling getProductCategoriesTree'
            );
        }

        $resourcePath = '/contents/product-categories:tree';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;




        // body params
        $_tempBody = null;
        if (isset($product_categories_tree_request)) {
            $_tempBody = $product_categories_tree_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation getProductCategory
     *
     * Запрос ProductCategory по ID
     *
     * @param  int $id Числовой id (required)
     * @param  string $include Связанные сущности для подгрузки, через запятую (optional)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CmsClient\Dto\ProductCategoryResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse
     */
    public function getProductCategory($id, $include = null)
    {
        list($response) = $this->getProductCategoryWithHttpInfo($id, $include);
        return $response;
    }

    /**
     * Operation getProductCategoryWithHttpInfo
     *
     * Запрос ProductCategory по ID
     *
     * @param  int $id Числовой id (required)
     * @param  string $include Связанные сущности для подгрузки, через запятую (optional)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CmsClient\Dto\ProductCategoryResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function getProductCategoryWithHttpInfo($id, $include = null)
    {
        $request = $this->getProductCategoryRequest($id, $include);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CmsClient\Dto\ProductCategoryResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ProductCategoryResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 404:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CmsClient\Dto\ProductCategoryResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ProductCategoryResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation getProductCategoryAsync
     *
     * Запрос ProductCategory по ID
     *
     * @param  int $id Числовой id (required)
     * @param  string $include Связанные сущности для подгрузки, через запятую (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getProductCategoryAsync($id, $include = null)
    {
        return $this->getProductCategoryAsyncWithHttpInfo($id, $include)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation getProductCategoryAsyncWithHttpInfo
     *
     * Запрос ProductCategory по ID
     *
     * @param  int $id Числовой id (required)
     * @param  string $include Связанные сущности для подгрузки, через запятую (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function getProductCategoryAsyncWithHttpInfo($id, $include = null)
    {
        $returnType = '\Ensi\CmsClient\Dto\ProductCategoryResponse';
        $request = $this->getProductCategoryRequest($id, $include);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'getProductCategory'
     *
     * @param  int $id Числовой id (required)
     * @param  string $include Связанные сущности для подгрузки, через запятую (optional)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function getProductCategoryRequest($id, $include = null)
    {
        // verify the required parameter 'id' is set
        if ($id === null || (is_array($id) && count($id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $id when calling getProductCategory'
            );
        }
        if ($id < 1) {
            throw new \InvalidArgumentException('invalid value for "$id" when calling ProductCategoriesApi.getProductCategory, must be bigger than or equal to 1.');
        }


        $resourcePath = '/contents/product-categories/{id}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if (is_array($include)) {
            $include = ObjectSerializer::serializeCollection($include, '', true);
        }
        if ($include !== null) {
            $queryParams['include'] = $include;
        }


        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                '{' . 'id' . '}',
                ObjectSerializer::toPathValue($id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation massDeleteProductCategory
     *
     * Массовое удаление объектов типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\MassDeleteProductCategoriesRequest $mass_delete_product_categories_request mass_delete_product_categories_request (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CmsClient\Dto\EmptyDataResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse
     */
    public function massDeleteProductCategory($mass_delete_product_categories_request)
    {
        list($response) = $this->massDeleteProductCategoryWithHttpInfo($mass_delete_product_categories_request);
        return $response;
    }

    /**
     * Operation massDeleteProductCategoryWithHttpInfo
     *
     * Массовое удаление объектов типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\MassDeleteProductCategoriesRequest $mass_delete_product_categories_request (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CmsClient\Dto\EmptyDataResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function massDeleteProductCategoryWithHttpInfo($mass_delete_product_categories_request)
    {
        $request = $this->massDeleteProductCategoryRequest($mass_delete_product_categories_request);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CmsClient\Dto\EmptyDataResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\EmptyDataResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 404:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CmsClient\Dto\EmptyDataResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\EmptyDataResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation massDeleteProductCategoryAsync
     *
     * Массовое удаление объектов типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\MassDeleteProductCategoriesRequest $mass_delete_product_categories_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function massDeleteProductCategoryAsync($mass_delete_product_categories_request)
    {
        return $this->massDeleteProductCategoryAsyncWithHttpInfo($mass_delete_product_categories_request)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation massDeleteProductCategoryAsyncWithHttpInfo
     *
     * Массовое удаление объектов типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\MassDeleteProductCategoriesRequest $mass_delete_product_categories_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function massDeleteProductCategoryAsyncWithHttpInfo($mass_delete_product_categories_request)
    {
        $returnType = '\Ensi\CmsClient\Dto\EmptyDataResponse';
        $request = $this->massDeleteProductCategoryRequest($mass_delete_product_categories_request);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'massDeleteProductCategory'
     *
     * @param  \Ensi\CmsClient\Dto\MassDeleteProductCategoriesRequest $mass_delete_product_categories_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function massDeleteProductCategoryRequest($mass_delete_product_categories_request)
    {
        // verify the required parameter 'mass_delete_product_categories_request' is set
        if ($mass_delete_product_categories_request === null || (is_array($mass_delete_product_categories_request) && count($mass_delete_product_categories_request) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $mass_delete_product_categories_request when calling massDeleteProductCategory'
            );
        }

        $resourcePath = '/contents/product-categories:mass-delete';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;




        // body params
        $_tempBody = null;
        if (isset($mass_delete_product_categories_request)) {
            $_tempBody = $mass_delete_product_categories_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation replaceProductCategory
     *
     * Замена объекта типа ProductCategory
     *
     * @param  int $id Числовой id (required)
     * @param  \Ensi\CmsClient\Dto\ProductCategoryForReplace $product_category_for_replace product_category_for_replace (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CmsClient\Dto\CreateProductCategoriesResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse
     */
    public function replaceProductCategory($id, $product_category_for_replace)
    {
        list($response) = $this->replaceProductCategoryWithHttpInfo($id, $product_category_for_replace);
        return $response;
    }

    /**
     * Operation replaceProductCategoryWithHttpInfo
     *
     * Замена объекта типа ProductCategory
     *
     * @param  int $id Числовой id (required)
     * @param  \Ensi\CmsClient\Dto\ProductCategoryForReplace $product_category_for_replace (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CmsClient\Dto\CreateProductCategoriesResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function replaceProductCategoryWithHttpInfo($id, $product_category_for_replace)
    {
        $request = $this->replaceProductCategoryRequest($id, $product_category_for_replace);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CmsClient\Dto\CreateProductCategoriesResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\CreateProductCategoriesResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 404:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CmsClient\Dto\CreateProductCategoriesResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\CreateProductCategoriesResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation replaceProductCategoryAsync
     *
     * Замена объекта типа ProductCategory
     *
     * @param  int $id Числовой id (required)
     * @param  \Ensi\CmsClient\Dto\ProductCategoryForReplace $product_category_for_replace (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function replaceProductCategoryAsync($id, $product_category_for_replace)
    {
        return $this->replaceProductCategoryAsyncWithHttpInfo($id, $product_category_for_replace)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation replaceProductCategoryAsyncWithHttpInfo
     *
     * Замена объекта типа ProductCategory
     *
     * @param  int $id Числовой id (required)
     * @param  \Ensi\CmsClient\Dto\ProductCategoryForReplace $product_category_for_replace (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function replaceProductCategoryAsyncWithHttpInfo($id, $product_category_for_replace)
    {
        $returnType = '\Ensi\CmsClient\Dto\CreateProductCategoriesResponse';
        $request = $this->replaceProductCategoryRequest($id, $product_category_for_replace);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'replaceProductCategory'
     *
     * @param  int $id Числовой id (required)
     * @param  \Ensi\CmsClient\Dto\ProductCategoryForReplace $product_category_for_replace (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function replaceProductCategoryRequest($id, $product_category_for_replace)
    {
        // verify the required parameter 'id' is set
        if ($id === null || (is_array($id) && count($id) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $id when calling replaceProductCategory'
            );
        }
        if ($id < 1) {
            throw new \InvalidArgumentException('invalid value for "$id" when calling ProductCategoriesApi.replaceProductCategory, must be bigger than or equal to 1.');
        }

        // verify the required parameter 'product_category_for_replace' is set
        if ($product_category_for_replace === null || (is_array($product_category_for_replace) && count($product_category_for_replace) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $product_category_for_replace when calling replaceProductCategory'
            );
        }

        $resourcePath = '/contents/product-categories/{id}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;



        // path params
        if ($id !== null) {
            $resourcePath = str_replace(
                '{' . 'id' . '}',
                ObjectSerializer::toPathValue($id),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($product_category_for_replace)) {
            $_tempBody = $product_category_for_replace;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'PUT',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation searchProductCategories
     *
     * Поиск объектов типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\SearchProductCategoriesRequest $search_product_categories_request search_product_categories_request (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CmsClient\Dto\SearchProductCategoriesResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse
     */
    public function searchProductCategories($search_product_categories_request)
    {
        list($response) = $this->searchProductCategoriesWithHttpInfo($search_product_categories_request);
        return $response;
    }

    /**
     * Operation searchProductCategoriesWithHttpInfo
     *
     * Поиск объектов типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\SearchProductCategoriesRequest $search_product_categories_request (required)
     *
     * @throws \Ensi\CmsClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CmsClient\Dto\SearchProductCategoriesResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse|\Ensi\CmsClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function searchProductCategoriesWithHttpInfo($search_product_categories_request)
    {
        $request = $this->searchProductCategoriesRequest($search_product_categories_request);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CmsClient\Dto\SearchProductCategoriesResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\SearchProductCategoriesResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 404:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CmsClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CmsClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CmsClient\Dto\SearchProductCategoriesResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\SearchProductCategoriesResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CmsClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation searchProductCategoriesAsync
     *
     * Поиск объектов типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\SearchProductCategoriesRequest $search_product_categories_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function searchProductCategoriesAsync($search_product_categories_request)
    {
        return $this->searchProductCategoriesAsyncWithHttpInfo($search_product_categories_request)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation searchProductCategoriesAsyncWithHttpInfo
     *
     * Поиск объектов типа ProductCategory
     *
     * @param  \Ensi\CmsClient\Dto\SearchProductCategoriesRequest $search_product_categories_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function searchProductCategoriesAsyncWithHttpInfo($search_product_categories_request)
    {
        $returnType = '\Ensi\CmsClient\Dto\SearchProductCategoriesResponse';
        $request = $this->searchProductCategoriesRequest($search_product_categories_request);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'searchProductCategories'
     *
     * @param  \Ensi\CmsClient\Dto\SearchProductCategoriesRequest $search_product_categories_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function searchProductCategoriesRequest($search_product_categories_request)
    {
        // verify the required parameter 'search_product_categories_request' is set
        if ($search_product_categories_request === null || (is_array($search_product_categories_request) && count($search_product_categories_request) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $search_product_categories_request when calling searchProductCategories'
            );
        }

        $resourcePath = '/contents/product-categories:search';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;




        // body params
        $_tempBody = null;
        if (isset($search_product_categories_request)) {
            $_tempBody = $search_product_categories_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
